﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.86
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI

	Private CustomListView1 As CustomListView
	Private PCLV As PreoptimizedCLV
	Private MediaManager As SimpleMediaManager
	Type MyImageData (IndexOfFirstImage As Int)
	
	Type M3UFileParsed(FirstLineData As List, SecondLineData As List, _
					   ChannelName As List, IconLink As List, StreamResolution As List)
	
	Public MyM3UFileParsed As M3UFileParsed

End Sub

'You can add more parameters here.
Public Sub Initialize
	MyM3UFileParsed.Initialize
	
	MyM3UFileParsed.FirstLineData.Initialize
	MyM3UFileParsed.SecondLineData.Initialize
	MyM3UFileParsed.ChannelName.Initialize
	MyM3UFileParsed.IconLink.Initialize
	MyM3UFileParsed.StreamResolution.Initialize
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MediaSelectionBy4")
	
	MediaManager.Initialize
	PCLV.Initialize(Me, "PCLV", CustomListView1)
	MediaManager.DefaultBackgroundColor = Colors.Black
	'MediaManager.DefaultForegroundColor = Colors.Black
	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
Sub B4XPage_Appear
	
End Sub
Sub B4XPage_Resize (Width As Int, Height As Int)

End Sub
Sub B4XPage_MenuClick (Tag As String)

End Sub

Sub GetM3uLink(url As String)
	Dim job As HttpJob
	job.Initialize("Job", Me)
	job.Tag = "Download Arabic"

	Dim poststr As String = url
	Log(poststr)
	
	job.Download(poststr)
	
	job.GetRequest.Setheader("Accept", "application/json")
	job.GetRequest.SetContentEncoding("text/plain")
	
End Sub

Sub JobDone (Job As HttpJob)
	Log("JobName = " & Job.JobName & ", Success = " & Job.Success)
	Log("JobTag = " & Job.Tag)
	
	Try
		If (Job.Success = True) Then
			'Get Data from file
			Dim FileData As String = Job.GetString
			
			'Split Data
			Dim strData() As String
			strData = Regex.Split("#EXTINF:", FileData)
						
			'#EXTINF: contains 2 or 3 line feed with Info and URL
			MyM3UFileParsed.FirstLineData.Clear
			MyM3UFileParsed.SecondLineData.Clear
			MyM3UFileParsed.ChannelName.Clear
			MyM3UFileParsed.IconLink.Clear
			MyM3UFileParsed.StreamResolution.Clear
			
			'Log(strData.Length - 1)
			
			For x = 0 To strData.Length - 1
				If strData(x) = "" Then
					'dont add empty field
				Else If strData(x).Contains("#EXTM3U") Then
					'dont add the #EXTM3U which is always in first line of the file
				Else
				
					'Parse the list that contains 2 or 3 line of data
					'1st = Info and Channel Name
					'2nd = URL of stream (2nd line)
					'3rd = URL of stream (3rd line) and Referral Url (2nd Line)
					Dim GetData As String
					GetData = strData(x)
										
					'Seen EXTVLCOPT = 3 line feed Else 2 line feed
					ParseLineData(GetData)
										
				End If
			Next
			
		Else
			B4XPages.MainPage.LastUrlName = ""	'Reset so it will refresh again			
			'Display Error
			ToastMessageShow("Error: " & Job.ErrorMessage, True)
					
		End If
	Catch
		B4XPages.MainPage.LastUrlName = ""	'Reset so it will refresh again
		Log("Error in JobDone")
	End Try
	
	Job.Release
	
	If MyM3UFileParsed.ChannelName.Size >= 1 Then
		Dim height As Int = 150dip

		For i = 1 To MyM3UFileParsed.ChannelName.Size Step 4
			PCLV.AddItem(height, xui.Color_Black, CreateMyImageData(i))
		Next
		
		PCLV.ShowScrollBar = False 'no fast scrolling
		PCLV.ExtraItems = 3
		PCLV.Commit
	Else
		B4XPages.MainPage.LastUrlName = ""	'Reset so it will refresh again
		ToastMessageShow("Error loading channels: < 1", True)
	End If
End Sub

Sub ParseLineData(GetData As String)
	
	'How many line feed (Usually 2 or 3)
	Dim strDataCRLF() As String
	strDataCRLF = Regex.Split(CRLF, GetData)
	
	Dim xLength As Int = strDataCRLF.Length
	Dim FLData, SLData, TLData As String
		
	If xLength = 2 Then
		'2 line feed
		FLData = strDataCRLF(0).Replace(CRLF, "")
		SLData = strDataCRLF(1).Replace(CRLF, "")
	Else if xLength = 3 Then
		'3 line feed
		FLData = strDataCRLF(0).Replace(CRLF, "")
		SLData = strDataCRLF(2).Replace(CRLF, "")
		TLData = strDataCRLF(1).Replace(CRLF, "") 'not used
	Else 
		Log("Error: Not known")
	End If
	
	MyM3UFileParsed.FirstLineData.Add(FLData)
	MyM3UFileParsed.SecondLineData.Add(SLData)
	
	'--------------------------------------------------------------------------------

	Dim WhatIndex As Int
	WhatIndex = FLData.LastIndexOf(",")	'Last Comma
			
	If WhatIndex <> - 1 Then
		'Get Channel name after comma to end of line and contains resolution info
		'Get Resolution
		Dim WhatChannelName As String
		WhatChannelName = FLData.SubString(WhatIndex + 1)
		
		'Index of resolution text (seen most inside () )
		Dim WhatCIndex As Int
		WhatCIndex = WhatChannelName.IndexOf("(")
		
		If WhatCIndex <> - 1 Then				
			'Add Channel Name (without eg..(1080) )
			Dim cChannel As String
			cChannel = WhatChannelName.SubString2(0, WhatCIndex)
			MyM3UFileParsed.ChannelName.Add(cChannel)
			
			'Add resolution info
			MyM3UFileParsed.StreamResolution.Add(WhatChannelName.SubString(WhatCIndex))
		Else
			'No resolution info with channel name
			MyM3UFileParsed.ChannelName.Add(WhatChannelName)
			
			'No Resolution info available
			MyM3UFileParsed.StreamResolution.Add("Not Available")
		End If
		
	Else
		MyM3UFileParsed.ChannelName.Add("Not Available")
		MyM3UFileParsed.StreamResolution.Add("Not Available")
	End If
	
	'--------------------------------------------------------------------------------
	
	'Get Icon Link, Group Title and ID in First Line Data
	Dim GetFirstLineData() As String
	GetFirstLineData = Regex.Split(" ", FLData)
		
	For x3 = 0 To GetFirstLineData.Length - 1
		Dim DataGet As String = GetFirstLineData(x3)
			
		If DataGet.Contains("tvg-logo") Then
			Dim WhatIndexFirstQuote As Int
			WhatIndexFirstQuote = DataGet.IndexOf(QUOTE)
				
			If WhatIndexFirstQuote <> - 1 Then
				Dim ParseData As String
				ParseData = DataGet.SubString(WhatIndexFirstQuote + 1)
				ParseData = ParseData.Replace(QUOTE, "")
				MyM3UFileParsed.IconLink.Add(ParseData)
			End If
		End If
	Next
		
	'Add NA if none available
	If MyM3UFileParsed.ChannelName.Size <> MyM3UFileParsed.IconLink.Size Then
		MyM3UFileParsed.IconLink.Add("Not Available")
	End If

End Sub

Sub CustomListView1_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	For Each i As Int In PCLV.VisibleRangeChanged(FirstIndex, LastIndex)
		Dim item As CLVItem = CustomListView1.GetRawListItem(i)
		Dim pnl As B4XView = xui.CreatePanel("")
'		pnl.Color = Colors.Black
'		item.Color = Colors.Black
		'item.Panel.AddView(pnl, 0, 0, item.Panel.Width, item.Panel.Height)
		item.Panel.AddView(pnl, 0, 0, 100%x, item.Panel.Height)
		
		Dim data As MyImageData = item.Value
		
		'Create the item layout
		pnl.LoadLayout("item")
		
		For x = 0 To 3
			
			If (data.IndexOfFirstImage + x) <= MyM3UFileParsed.IconLink.Size Then
				Dim WhatListIndex As Int
				WhatListIndex = (data.IndexOfFirstImage + x) - 1
				
				Dim GetChannelName As String
				GetChannelName = MyM3UFileParsed.ChannelName.Get(WhatListIndex)
				
				pnl.GetView(x).GetView(1).Text = (data.IndexOfFirstImage + x) & " " & GetChannelName
				pnl.GetView(x).GetView(1).Tag = (data.IndexOfFirstImage + x)

				Dim GetIconLink As String
				GetIconLink = MyM3UFileParsed.IconLink.Get(WhatListIndex)
				'Log(GetIconLink)
				MediaManager.SetMedia(pnl.GetView(x).GetView(0), GetIconLink)
			End If
		Next
	Next
	
	'The purpose of this call is to find panels that are no longer in the views tree and cancel any ongoing request that is no longer relevant.
	'It also happens automatically from time to time but in this case, as many requests are sent frequently, it is better to force it to trim the cache.
	'Note that you need to add HU2_PUBLIC to the build configuration.
	MediaManager.TrimMediaCache
End Sub
Sub panelText_Click
	Dim panel As B4XView = Sender
	Dim label As B4XView = panel.GetView(1)
	Dim WhatIndex As Int = (label.tag - 1)
	Log("Channel " & (WhatIndex + 1))
	
	If WhatIndex <= MyM3UFileParsed.SecondLineData.Size Then
		Dim GetUrl As String = MyM3UFileParsed.SecondLineData.Get(WhatIndex)
		Dim GetChannelName As String = MyM3UFileParsed.ChannelName.Get(WhatIndex)
		
		B4XPages.ShowPage("Media Player")
		B4XPages.MainPage.Page3.GetStreamFile(GetUrl, WhatIndex, GetChannelName)
		B4XPages.MainPage.Page3.PopulateChannelListOnCLV
	Else
		Log("Error showing video and getting link")
	End If
End Sub

Public Sub CreateMyImageData (IndexOfFirstImage As Int) As MyImageData
	Dim t1 As MyImageData
	t1.Initialize
	t1.IndexOfFirstImage = IndexOfFirstImage
	Return t1
End Sub

Sub RefreshMedia(url As String)
	CustomListView1.Clear
	GetM3uLink(url)
End Sub


