﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.86
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	
	Public SimpleExoPlayerView1 As SimpleExoPlayerView
	Public Player As SimpleExoPlayer
	
	Private clvChannels As CustomListView
		
	Private lblEnterFullScreen As B4XView
	Private lblListChannels As B4XView
	
	Private VideoWidth, VideoHeight As Int
	
	Public SelectedChannelName As String
	Public SelecteChannelNumberIndex As String 'Index not channel number.  Just add 1 for channel number
End Sub

'You can add more parameters here.
Public Sub Initialize

End Sub

'This event will be called once, before the page becomes visible.
Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("ExoPlayer")
	Root.LoadLayout("ListViewChannels")
	
	Player.Initialize("player")
	SimpleExoPlayerView1.Player = Player
	
	lblEnterFullScreen.Visible = False
	
	'PopulateChannelListOnCLV 'done in page2
	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
Private Sub B4XPage_Appear
	B4XPages.SetTitle(Me, (SelecteChannelNumberIndex + 1) & " " & SelectedChannelName)
End Sub
Sub B4XPage_Resize (Width As Int, Height As Int)

End Sub
Sub B4XPage_MenuClick (Tag As String)

End Sub
Sub B4XPage_CloseRequest As ResumableSub
	'Close ListView Channel Panel
	If clvChannels.AsView.Visible = True Then
		clvChannels.AsView.Visible = False
		Return False
	End If
	
	Log("Player Pause")
	Player.Pause
  	Return True
End Sub

Sub GetStreamFile(url As String, ChannelNumberIndex As Int, ChannelName As String)
	'"https://jrtv-live.ercdn.net/jordanhd/jordanhd.m3u8"
	SelecteChannelNumberIndex = ChannelNumberIndex
	SelectedChannelName = ChannelName
	
	B4XPages.SetTitle(Me, (SelecteChannelNumberIndex + 1) & " " & SelectedChannelName)
	
	Player.Prepare(Player.CreateHLSSource(url))
	Player.Play
End Sub

Sub Player_Ready
	Log("Player Ready")
	
	Dim VideoFormat As JavaObject = Player
	VideoFormat = VideoFormat.GetFieldJO("player").RunMethod("getVideoFormat", Null)
	VideoWidth = VideoFormat.GetField("width")
	VideoHeight = VideoFormat.GetField("height")
	lblEnterFullScreen.Visible = True
'	PutLabelInVideoTopRightCorner(SimpleExoPlayerView1, lblEnterFullScreen)
End Sub
Sub Player_Complete
	Log("Player Complete")
End Sub
Sub Player_Error(Message As String)
	ToastMessageShow("Error loading channel", False)
	Log("Error: " & Message)
End Sub
Sub Player_TrackChanged
	Log("Player Changed")
End Sub

Public Sub PutLabelInVideoTopRightCorner(PlayerView As SimpleExoPlayerView, Label As B4XView)
	Dim PlayerRatio As Float = PlayerView.Width / PlayerView.Height
	Dim VideoRatio As Float = VideoWidth / VideoHeight
	Dim scale As Float = IIf(PlayerRatio > VideoRatio, PlayerView.Height / VideoHeight, PlayerView.Width / VideoWidth)
	Label.Top = PlayerView.Top + PlayerView.Height / 2 - VideoHeight / 2 * scale
	Label.Left = PlayerView.Left + PlayerView.Width / 2 + VideoWidth / 2 * scale - Label.Width
End Sub
Private Sub lblEnterFullScreen_Click
	StartActivity(FullScreen)
End Sub
Private Sub lblListChannels_Click
	clvChannels.AsView.Visible = True
End Sub

Sub PopulateChannelListOnCLV
	Dim GetSize As Int
	GetSize = B4XPages.MainPage.Page2.MyM3UFileParsed.ChannelName.Size
	Log(GetSize)
	
	Dim GetChannelName As String
	
	clvChannels.Clear
	For x = 0 To GetSize - 1
		GetChannelName = B4XPages.MainPage.Page2.MyM3UFileParsed.ChannelName.Get(x)
		clvChannels.AddTextItem((x + 1) & " " & GetChannelName, "clvChannels")
	Next
End Sub

Private Sub clvChannels_ItemClick (Index As Int, Value As Object)
	Dim WhatUrl As String = B4XPages.MainPage.Page2.MyM3UFileParsed.SecondLineData.Get(Index)
	Dim WhatChannelName As String = B4XPages.MainPage.Page2.MyM3UFileParsed.ChannelName.Get(Index)
	
	clvChannels.AsView.Visible = False
	GetStreamFile(WhatUrl, Index, WhatChannelName)
End Sub
